      /* Beseitigung von Datenmuell; Anfangszustand der Blockwelt */
         
 start:-
   sammle_muell,
   sammle_muell_neustart,
   asserta(position(tisch,bildschirm,15,2)),
   asserta(position(hut,tisch,14,7)),
   asserta(position(kasten,tisch,14,17)),
   asserta(position(grossblock,tisch,14,27)),
   asserta(position(kleinblock,tisch,14,37)),
   steuerung.
 start.

                       /* Steuerung des Dialogs */

 steuerung:-
   cls,
   zeichne_blockwelt,
   curset(16,0,0),
   sammle_muell,
   print('  ?- '),
   (erzeuge_wortliste(Satz);
    (!,print('  der satz enthaelt mindestens ein unbekanntes Wort'),nl,
       print('  oder er ist nicht mit "!" bzw. "?" abgeschlossen!'),
    nl,
    curset(24,65,0),
    print('taste ... '),
    get0(_),
    steuerung)),
   verstehe(Satz,[Modalitaet,Bedeutung]),!,
   (var(Modalitaet);
   reagiere(Bedeutung)),!,
   curset(24,65,0),
   print('taste ... '),
   get0(_),    
   steuerung.

        /* Umwandlung des eingelesenen Strings in eine Wortliste */
        /* und Tippfehlerkorrektur */

 erzeuge_wortliste(Liste):-
   ratom(String),
   (conc(_,'!',String);conc(_,'?',String)),
   string_liste(String,Liste1),!,
   korrigiere(Liste1,Liste),!.

 korrigiere(['!'],['!']):-!.
 korrigiere(['?'],['?']):-!.
 korrigiere([Kopf|Rest],[Kopf|Rest_neu]):-  
   lexikonregel(_,Kopf),
   korrigiere(Rest,Rest_neu),!.
 korrigiere([Kopf|Rest],[Wort|Rest_neu]):-
   lexikonregel(_,Wort),
   name(Kopf,Kopfliste),name(Wort,Wortliste),
   ers(_,Kopfliste,_,Wortliste),
   korrigiere(Rest,Rest_neu),!.
 korrigiere([Kopf|Rest],[Wort|Rest_neu]):-
   lexikonregel(_,Wort),
   name(Kopf,Kopfliste),name(Wort,Wortliste),
   einfueg(_,Wortliste,Kopfliste),
   korrigiere(Rest,Rest_neu),!.
 korrigiere([Kopf|Rest],[Wort|Rest_neu]):-
   lexikonregel(_,Wort),
   name(Kopf,Kopfliste),name(Wort,Wortliste),
   loesche(_,Wortliste,Kopfliste),
   korrigiere(Rest,Rest_neu),!. 
 korrigiere(_,_):-
   !,fail.
 
         /* syntaktisch-semantische Analyse eines eingegebenen Satzes */
   
 verstehe(Satz,[Modalitaet,[Praedikatsbedeutung|Ergaenzungsbedeutungen]]):-
   element(Modalitaetsindikator,[['?'],['!']]),
   verkette(Wortfolge,Modalitaetsindikator,Satz),
   praepariere_Antwort(Modalitaet,Wortfolge),
   ermittle_Modalitaet(Modalitaetsindikator,Modalitaet),
   analysiere(Wortfolge),
   print(Modalitaet,':'),nl,
   retract(praedikat([Praedikatsbedeutung|Kasusrollenliste])),
   besetze_Kasusrollen(Kasusrollenliste,Ergaenzungsbedeutungen_mit_Kasusrollen),
   print('   ',Praedikatsbedeutung,Ergaenzungsbedeutungen_mit_Kasusrollen),nl,
   anaphorisiere(Ergaenzungsbedeutungen_mit_Kasusrollen),
   kuerze(Ergaenzungsbedeutungen_mit_Kasusrollen,Ergaenzungsbedeutungen).
 verstehe(_,_):-
   print('  dieser satz ist nicht analysierbar!'),nl,nl.
   
 ermittle_Modalitaet(['!'],'  BEFEHL'):-
   asserta(ergaenzung([nom,def,system])).
 ermittle_Modalitaet(['?'],'  FRAGE').
 ermittle_Modalitaet(_,_):-!,fail.
 
 praepariere_Antwort('  FRAGE',Satz):-
   element(wo,Satz),asserta(fragewort(wo)).
 praepariere_Antwort('  FRAGE',Satz):-
   element(was,Satz),asserta(fragewort(was)).
 praepariere_Antwort('  FRAGE',Satz):-
   element(etwas,Satz),asserta(fragewort(etwas)).
 praepariere_Antwort(_,_).

 analysiere([]):-!.
 analysiere(Wortliste):-
   curwh(X,_),curset(X,3,0),
   konstruktion(ergaenzung,Wortliste,Rest,Ergaenzungsbedeutung),
   verkette(Ergaenzung,Rest,Wortliste),
   print(Ergaenzung,' '),nl,
   merke_ergaenzungsbedeutung(Ergaenzungsbedeutung),
   analysiere(Rest).
 analysiere(Wortliste):-
   curwh(X,_),curset(X,3,0),
   konstruktion(praedikat,Wortliste,Rest,Praedikatsbedeutung),
   verkette(Praedikat,Rest,Wortliste),
   print(Praedikat,' '),nl,
   glaette_liste(Praedikatsbedeutung,Praedikatsbedeutung_neu),
   asserta(praedikat(Praedikatsbedeutung_neu)),
   analysiere(Rest).
 
 merke_ergaenzungsbedeutung(Bedeutung):-
   glaette_liste(Bedeutung,Bedeutung_neu),
   assertz(ergaenzung(Bedeutung_neu)).
 
 anaphorisiere(_):-
   retract(anapher),!.  
 anaphorisiere(Sem):-
   element(Ergaenzung,Sem),
   (verkette(_,[Nomen,'THEMA'],Ergaenzung);
    verkette(_,[Nomen,'OBJEKT'],Ergaenzung)),
   (retract(anapher(_));true),
   asserta(anapher(Nomen)).
 
 konstruktion(Kategorie,Liste,Rest,Semliste):-
   ersetzungsregel(Kategorie,Subkategorien),
   subkategorien(Subkategorien,Liste,Rest,Semliste),
   print(Kategorie,' ',Subkategorien).
  
 subkategorien([],Restliste,Restliste,[]).  
 subkategorien([Kopf|Rest],Liste,Restliste,[Kopf_Semliste|Rest_Semliste]):-
   lexikonregel(Kopf,Wort),
   Liste=[Wort|Neuliste],
   wort_semliste(Kopf,Wort,Kopf_Semliste),
   subkategorien(Rest,Neuliste,Restliste,Rest_Semliste).
 subkategorien([Kopf|Rest],Liste,Restliste,Semliste):-
   konstruktion(Kopf,Liste,Neuliste,KopfSemliste),
   subkategorien(Rest,Neuliste,Restliste,RestSemliste),
   verkette(KopfSemliste,RestSemliste,Semliste).

 ersetzungsregel(praedikat,[vrb]).
 ersetzungsregel(ergaenzung,[pro]).
 ersetzungsregel(ergaenzung,[art,nom]).
 ersetzungsregel(ergaenzung,[art,adj,nom]).
 ersetzungsregel(ergaenzung,[prp,art,nom]).
 ersetzungsregel(ergaenzung,[prp,art,adj,nom]).
 ersetzungsregel(ergaenzung,[prp_art,nom]).
 
 lexikonregel(art,X):-element(X,[der,den,dem,ein,einen,einem]).
 lexikonregel(nom,X):-element(X,[system,hut,kasten,block,tisch]).
 lexikonregel(adj,X):-
  element(X,[grosse,grossen,grosser,kleine,kleinen,kleiner]).
 lexikonregel(pro,X):-
  element(X,[oben,wo,wohin,was,etwas,ihn,er,darauf,darin,hinein]).
 lexikonregel(vrb,X):-
  element(X,[ist,legt,lege,liegt,steht,stelle,stellt,hebe,hebt]).
 lexikonregel(prp,X):-element(X,[in,auf]).
 lexikonregel(prp_art,im).

 wort_semliste(nom,Wort,[Kennzeichnung]):-
   retract(adjektiv(Adjektiv)),
   conc(Adjektiv,Wort,Kennzeichnung);
   Kennzeichnung=Wort.
 wort_semliste(adj,X,[]):-
   element(X,[grosse,grossen,grosser]),
   asserta(adjektiv(gross)).
 wort_semliste(adj,X,[]):-
   element(X,[kleine,kleinen,kleiner]),
   asserta(adjektiv(klein)).
 wort_semliste(pro,wo,[prp,dat,ind,x]).
 wort_semliste(pro,wohin,[prp,akk,ind,x]).
 wort_semliste(pro,X,[var,ind,x]):-element(X,[was,etwas]).
 wort_semliste(pro,oben,[prp,dat,def,oben]).
 wort_semliste(pro,ihn,[akk,def,Nomen]):-
   anapher(Nomen),asserta(anapher).
 wort_semliste(pro,er,[nom,def,Nomen]):-
   anapher(Nomen),asserta(anapher).
 wort_semliste(pro,darauf,[prp,X,def,Nomen]):-
   anapher(Nomen),asserta(anapher).
 wort_semliste(pro,darin,[prp,dat,def,Nomen]):-
   anapher(Nomen),asserta(anapher).
 wort_semliste(pro,hinein,[prp,akk,def,Nomen]):-
   anapher(Nomen),asserta(anapher).
 wort_semliste(art,der,[nom,def]).
 wort_semliste(art,dem,[dat,def]).
 wort_semliste(art,den,[akk,def]).
 wort_semliste(art,ein,[nom,ind]).
 wort_semliste(art,einem,[dat,ind]).
 wort_semliste(art,einen,[akk,ind]).
 wort_semliste(prp_art,im,[prp,dat,def]).
 wort_semliste(prp,X,[prp]):-lexikonregel(prp,X).
 wort_semliste(vrb,X,[position,[nom,'THEMA'],[prp,dat,'ORT']]):-
   element(X,[ist,liegt,steht]).
 wort_semliste(vrb,X,[ablegen,[nom,'AGENT'],[akk,'OBJEKT'],[prp,akk,'ZIEL']]):-
   element(X,[legt,lege,stellt,stelle]).
 wort_semliste(vrb,X,[heben,[nom,'AGENT'],[akk,'OBJEKT']]):-
   element(X,[hebe,hebt]).

 besetze_Kasusrollen([],[]).
 besetze_Kasusrollen([[Kasus,Rolle]|Rest],[[Def,Wort,Rolle]|Neurest]):-
   ergaenzung([Kasus,Def,Wort]),
   retract(ergaenzung([Kasus,Def,Wort])),
   besetze_Kasusrollen(Rest,Neurest).
 besetze_Kasusrollen([[Kasus,Rolle]|Rest],[[ind,x,Rolle]|Neurest]):-
   ergaenzung([var,ind,x]),
   retract(ergaenzung([var,ind,x])),
   besetze_Kasusrollen(Rest,Neurest).
 besetze_Kasusrollen([[prp,Kasus,Rolle]|Rest],[[Def,Wort,Rolle]|Neurest]):-
   ergaenzung([prp,Kasus,Def,Wort]),
   retract(ergaenzung([prp,Kasus,Def,Wort])),
   besetze_Kasusrollen(Rest,Neurest).
   
    /* Reaktion des Systems: Antwort auf Fragen, Ausfuehrung von Befehlen */

 reagiere([position|Argumentliste]):-
   element([def,block],Argumentliste),
   print('  ANTWORT: welcher block ist gemeint?'),nl.
 reagiere([position|Argumentliste]):-
   ergaenze(position,Argumentliste,Argumentliste_neu),
   suchvar(Argumentliste_neu,L),
   asserta(eins),
   verkette(Argumentliste_neu,[_,_],Liste),
   Proposition=..[position|Liste],
   print('  ANTWORT: '),
   (Proposition,
   n_te(Argumentliste_neu,L,Antw),
   (bilde_Antwort(Antw,Antwort),
   print(Antwort,'  '),fail);(Proposition,retract(eins))).
 reagiere([position|_]):-
   retract(eins),
   print('nichts!'),nl.
 reagiere([position|Argumentliste]):-
   ergaenze(position,Argumentliste,Argumentliste_neu),
   verkette(Argumentliste_neu,[_,_],Liste),
   Proposition=..[position|Liste],
   (Proposition,
   (print('  ANTWORT: ja!'),nl,fail);Proposition).
 reagiere([position|_]):-
   print('  ANTWORT: nein!'),nl.
 reagiere([Praed|Argumentliste]):-
   Praed \= position,
   ergaenze(Praed,Argumentliste,Argumentliste_neu),
   zweifel,
   ((gedankenexperiment(Praed,Argumentliste_neu),!);
   (Proposition=..[Praed|Argumentliste_neu],
    Proposition,
    (((element(grossblock,Argumentliste_neu),
                retract(anapher(block)),asserta(anapher(grossblock)));
      (element(kleinblock,Argumentliste_neu),
                retract(anapher(block)),asserta(anapher(kleinblock))))
     ;true),
    print('  REAKTION: in ordnung!'),nl)).
 reagiere([Praed|Argumentliste]):-
   Praed \= position,
   ergaenze(Praed,Argumentliste,Argumentliste_neu),
   Proposition=..[Praed|Argumentliste_neu],
    Proposition,
    (((element(grossblock,Argumentliste_neu),
                retract(anapher(block)),asserta(anapher(grossblock)));
     (element(kleinblock,Argumentliste_neu),
                retract(anapher(block)),asserta(anapher(kleinblock))))
     ;true),
   print('  REAKTION: in ordnung!'),nl.
 reagiere(_):-
   print('  REAKTION: dieser befehl ist nicht ausfuehrbar!'),nl.
  
 ergaenze(_,[],[]):-!.
 ergaenze(Praed,[[ind,block]|Rest],[Nomen|Neurest]):-
   element(Nomen,[grossblock,kleinblock]),
   ergaenze(Praed,Rest,Neurest).
 ergaenze(Praed,[[def,block]|Rest],[Nomen|Neurest]):-
   merke_zweifel,
   element(Nomen,[grossblock,kleinblock]),
   ergaenze(Praed,Rest,Neurest).
 ergaenze(Praed,[[def,Nomen]|Rest],[Nomen|Neurest]):-
   ergaenze(Praed,Rest,Neurest).
 ergaenze(Praed,[[ind,x]|Rest],[Variable|Neurest]):-
   ergaenze(Praed,Rest,Neurest).

 heben(system,Variable):-
   var(Variable),
   position(Variable,_,_,_),
   not(position(Variable,oben,_,_)),
   not(position(_,Variable,_,_)),
   obenposition(Z,S),
   not(position(_,oben,Z,S)),
   retract(position(Variable,_,_,_)),
   assertz(position(Variable,oben,Z,S)),
   (retract(anapher(_));true),
   asserta(anapher(Variable)).
 heben(system,tisch):-
   print('  REAKTION: der tisch kann nicht bewegt werden!'),nl,!,fail.
 heben(system,Objekt):-
   not(position(Objekt,oben,_,_)),
   not(position(_,Objekt,_,_)),
   obenposition(Z,S),
   not(position(_,oben,Z,S)),
   retract(position(Objekt,_,_,_)),
   assertz(position(Objekt,oben,Z,S)),!.

 ablegen(system,Objekt,Variable):-
   var(Variable),
   ((position(Variable,_,_,_),Variable \= hut,not(position(_,Variable,_,_)));
         Variable = tisch),
   ablegen(system,Objekt,Variable).
 ablegen(system,Variable,Ziel):-
   var(Variable),
   position(Variable,_,_,_),
   not(position(_,Variable,_,_)),
   ablegen(system,Variable,Ziel),
   (retract(anapher(_));true),
   asserta(anapher(Variable)).
 ablegen(system,tisch,_):-
   print('  REAKTION: der tisch kann nicht bewegt werden!'),nl,!,fail.
 ablegen(system,_,hut):-
   print('  REAKTION: auf dem hut kann nichts abgelegt werden!'),nl,!,fail.
 ablegen(system,X,kasten):-
   position(Y,kasten,_,_),
   X \= Y,!,
   print('  REAKTION: im kasten befindet sich bereits '),
   asserta(fragewort(was)),
   bilde_Antwort(Y,Y_antwort),
   print(Y_antwort,'!'),
   retract(fragewort(was)),nl,!,fail.
 ablegen(system,Objekt,tisch):-
   not(position(_,Objekt,_,_)),
   not(position(Objekt,tisch,_,_)),
   tischposition(Z,S),
   not(position(_,tisch,Z,S)),
   retract(position(Objekt,_,_,_)),
   assertz(position(Objekt,tisch,Z,S)).
 ablegen(system,Objekt,Ziel):-
   not(position(_,Objekt,_,_)),
   not(position(_,Ziel,_,_)),
   Objekt \= Ziel,
   position(Objekt,Ort,_,_),
   Ort \= Ziel,
   position(Ziel,_,Zo,So),
   Zn is Zo - 2,
   retract(position(Objekt,Ort,_,_)),
   assertz(position(Objekt,Ziel,Zn,So)).
 
 bilde_Antwort(oben,oben):-
   fragewort(wo),!.  
 bilde_Antwort(kasten,'im kasten'):-  
   fragewort(wo),!.
 bilde_Antwort(kleinblock,'auf dem kleinen block'):-  
   fragewort(wo),!.
 bilde_Antwort(kleinblock,'der kleine block'):-  
   fragewort(X),element(X,[was,etwas]),!.
 bilde_Antwort(grossblock,'auf dem grossen block'):-  
   fragewort(wo),!.
 bilde_Antwort(grossblock,'der grosse block'):-  
   fragewort(X),element(X,[was,etwas]),!.
 bilde_Antwort(Nomen,Antwort):-  
   fragewort(wo),
   conc('auf dem ',Nomen,Antwort),!.
 bilde_Antwort(Nomen,Antwort):-  
   fragewort(X),element(X,[was,etwas]),
   conc('der ',Nomen,Antwort),!.

 merke_zweifel:-zweifel.
 merke_zweifel:-asserta(zweifel).

 gedankenexperiment(Praed,Argumentliste_neu):-
   TestProposition1=..[Praed,test|Argumentliste_neu],
   TestProposition1,!,
   ((ersetze(grossblock,[Praed,test|Argumentliste_neu],kleinblock,Liste),!);
    (ersetze(kleinblock,[Praed,test|Argumentliste_neu],grossblock,Liste),!)),
   TestProposition2=..Liste,
   TestProposition2,
   print('  REAKTION: dieser befehl kann mit beiden bloecken ausgefuehrt werden.'),nl,
   print('  REAKTION: welcher block ist gemeint?'),nl.

 heben(test,system,Objekt):-
   not(position(_,Objekt,_,_)),
   not(position(Objekt,oben,_,_)).

 ablegen(test,system,Objekt,Variable):-
   var(Variable),
   ((position(Variable,_,_,_),not(position(_,Variable,_,_)));Variable = tisch),
   ablegen(system,Objekt,Variable).
 ablegen(test,system,Variable,Ziel):-
   var(Variable),
   position(Variable,_,_,_),
   not(position(_,Variable,_,_)),
   ablegen(system,Variable,Ziel).
 ablegen(test,system,tisch,Ziel):-
   !,fail.
 ablegen(test,system,X,kasten):-
   position(Y,kasten,_,_),
   !,fail.
 ablegen(test,system,Objekt,Ziel):-
   not(position(_,Objekt,_,_)),
   (not(position(_,Ziel,_,_));Ziel=tisch),
   Objekt \= Ziel,
   position(Objekt,Ort,_,_),
   Ort \= Ziel.

        /* graphische Darstellung der Blockwelt, Bildschirmtexte */
 
 zeichne_blockwelt:-
   curset(2,49,0),
   print('SIMPEL'),
   curset(3,49,0),
   print('Ein experimentelles Programm'),
   curset(4,49,0),
   print('zum Problem des Verstehens'),
   curset(5,49,0),
   print('natuerlicher Sprachen.'),
   curset(6,49,0),
   print('1991 Klaus Bayer'),
   curset(7,49,0),
   print('Universitaet Hannover'),
   curset(8,50,0),linie(28),nl,
   curset(9,49,0),
   print('wissen:'),nl,
   drucke_wissen,
   curset(16,55,0),
   ((anapher(X),X \= x,print('Thema: ',X));true),
   fail.
 zeichne_blockwelt:-
   position(X,_,Z,S),
   X(Z,S),
   fail.
 zeichne_blockwelt.

 drucke_wissen:-
   position(X,Y,_,_),
   curwh(Z,S),curset(Z,49,0),
   print('pos(',X,',',Y,')'),nl,
   fail.
 drucke_wissen.

 tischposition(14,7).
 tischposition(14,17).
 tischposition(14,27).
 tischposition(14,37).
 
 obenposition(5,7).
 obenposition(5,17).
 obenposition(5,27).
 obenposition(5,37).

 kleinblock(Z,S):-
   Sa is S + 2,
   curset(Z,Sa,0),
   put(177,177,177),
   Zn is Z - 1,
   curset(Zn,Sa,0),
   put(177,177,177).

 hut(Z,S):-
   Sa is S + 2,
   curset(Z,Sa,0),
   put(219,219,219),
   Zn is Z - 1,
   curset(Zn,Sa,0),
   put(32,219,32).  
   
 grossblock(Z,S):-
   Sa is S + 1,
   curset(Z,Sa,0),
   put(178,178,178,178,178),
   Zn is Z - 1,
   curset(Zn,Sa,0),
   put(178,178,178,178,178).

 kasten(Z,S):-
   curset(Z,S,0),
   put(219,219,219,219,219,219,219), 
   Z1 is Z - 1,
   curset(Z1,S,0),
   put(219),
   S1 is S + 6,
   curset(Z1,S1,0),
   put(219),
   Z2 is Z1 - 1,
   curset(Z2,S,0),
   put(219),
   curset(Z2,S1,0),
   put(219),
   Z3 is Z2 - 1,
   curset(Z3,S,0), 
   put(219),
   curset(Z3,S1,0),
   put(219).
   
 tisch(Z,S):-
   curset(1,2,0),put(218),linie(44),put(191),
   curset(2,2,0),put(179),curset(2,47,0),put(179),
   curset(3,2,0),put(179),curset(3,47,0),put(179),
   curset(4,2,0),put(179),curset(4,47,0),put(179),
   curset(5,2,0),put(179),curset(5,47,0),put(179),
   curset(6,2,0),put(179),curset(6,47,0),put(179),
   curset(7,2,0),put(179),curset(7,47,0),put(179),
   curset(8,2,0),put(179),curset(8,47,0),put(179),
   curset(9,2,0),put(179),curset(9,47,0),put(179),
   curset(10,2,0),put(179),curset(10,47,0),put(179),
   curset(11,2,0),put(179),curset(11,47,0),put(179),
   curset(12,2,0),put(179),curset(12,47,0),put(179),
   curset(13,2,0),put(179),curset(13,47,0),put(179),
   curset(14,2,0),put(179),curset(14,47,0),put(179),
   curset(15,2,0),put(179),curset(15,47,0),put(179),
   curset(Z,S,0),put(192),linie(44),put(217),
   curset(Z,50,0),linie(28),!.
   
 linie(0):-!.
 linie(N):-
   put(196),
   Neu is N - 1,
   linie(Neu).

      /* Hilfspraedikate, Standardroutinen fuer Listen und Strings */

 string_liste([],[]).  
 string_liste(String,[Kopf_liste|Rest_liste]):-
   fronttoken(String,Kopf_liste,Reststring),
   string_liste(Reststring,Rest_liste).
   
 fronttoken(String,Token,Rest):- 
   name(String,Stringliste),
   front(Stringliste,Tokenliste,Restliste),
   name(Token,Tokenliste),
   name(Rest,Restliste),!.
 fronttoken(String,String,[]):-!.
  
 front([],[],[]):-!.
 front([32|Rest],[],Rest):-!.
 front([Erster|Rest],[Erster|Tokenrest],E):-!,
   front(Rest,Tokenrest,E).
  
 conc(String,[],String):-!.
 conc([],String,String):-!.
 conc(String1,String2,String3):-
   xname(String1,List1),
   xname(String2,List2),
   xname(String3,List3),
   verkette(List1,List2,List3),
   name(String1,List1),
   name(String2,List2),
   name(String3,List3),
   !.

 xname(String,X):-
   var(String),!.
 xname(String,Liste):-
   name(String,Liste),!.
   
 element(X,[X|_]).
 element(X,[_|R]):-element(X,R).
 
 verkette([],L,L).
 verkette([K|L1],L2,[K|L3]):-verkette(L1,L2,L3).

 glaette_liste([Liste1,Liste2,Liste3,Liste4],Listec):-
   verkette(Liste1,Liste2,Listea),
   verkette(Listea,Liste3,Listeb),
   verkette(Listeb,Liste4,Listec). 
 glaette_liste([Liste1,Liste2,Liste3],Listeb):-
   verkette(Liste1,Liste2,Listea),
   verkette(Listea,Liste3,Listeb).
 glaette_liste([Liste1,Liste2],Listea):-
   verkette(Liste1,Liste2,Listea).
 glaette_liste([Liste1],Liste1).

 kuerze([],[]).
 kuerze([[Def,Nom,_]|Rest],[[Def,Nom]|Neurest]):-
   kuerze(Rest,Neurest).

 suchvar(Liste,Pos):-
  such(Liste,1,Pos).

 such([Var|_],Pos,Pos):-
  var(Var).
 such([_|Rest],Pos,P):-
   Posn is Pos + 1,!,
   such(Rest,Posn,P).

 n_te([K|_],1,K).
 n_te([_|R],N,E):-
   N1 is N-1,
   n_te(R,N1,E).

 laenge([],0).
 laenge([_|R],L1):-
   laenge(R,L),
   L1 is L+1.

 ersetze(A,AL,N,NL):-
   element(A,AL),!,
   ers(A,AL,N,NL).
   
 ers(_,[],_,[]):-!.
 ers(E,[E|R],K,[K|R]):-
   !,
   ers(E,R,K,L).
 ers(E,[Y|R],K,[Y|L]):-
   ers(E,R,K,L).
   
 loesche(_,[],[]).
 loesche(K,[K|R],R).
 loesche(X,[K|R1],[K|R2]):-
   loesche(X,R1,R2).

 einfueg(X,L,[X|L]).
 einfueg(X,[K|R1],[K|R2]):-
   einfueg(X,R1,R2).

 sammle_muell:- 
   retract(fragewort(_)),
   fail.
 sammle_muell:-
   retract(zweifel),
   fail.
 sammle_muell:-
   retract(ergaenzung(_)),
   fail.
 sammle_muell:-
   retract(praedikat(_)),
   fail.
 sammle_muell.
 
 sammle_muell_neustart:-
   retract(position(_,_,_,_)),
   fail.
 sammle_muell_neustart:-
   retract(adjektiv(_)),
   fail.
 sammle_muell_neustart:-
   retract(anapher(_)),
   fail.
 sammle_muell_neustart:-
   retract(anapher),
   fail.
 sammle_muell_neustart:-
   retract(eins),
   fail.
 sammle_muell_neustart.
 